class SpaceBlob extends Goon{   /////////////////////////////////   SpaceBlob             //////////////////////////////////////////////////////////////
int speed=2;
ArrayList points = new ArrayList();
int pointCount=65;
float[] radCoef=new float[pointCount];
float radmin=.93;
float radmax=1.07;
ArrayList spawn=new ArrayList();
int counter=0;
int rate=100;
int baddieLevel=0;
int deathCountdown=10;
  SpaceBlob(Vector3D p){
    mass=40;
    pos= p.copy();
    pos.x+=pos.x/abs(pos.x)*250;
    pos.y+=pos.y/abs(pos.y)*250;
    acc=new Vector3D();
    vel=new Vector3D(speed,PI/4,true);
    rad=650;
    type = SPACEBLOB;
    SpaceBlobDot f=new SpaceBlobDot(pos.copy(),this);
    for(int i=0; i<pointCount; i++){
     SpaceBlobDot d=new SpaceBlobDot(pos.copy(),this,f); 
     points.add(d);
     radCoef[i]=random(radmin,radmax);
     f=d;
    }
    for(int j=0;j<5;j++){
      addBaddie();
    }
   
    
  }

void checkCollision(){
  if(h.hitWingMan(pos,rad)){
     rad-=6;
     vel.mult(1.01);
     baddieLevel=0;
     if(spawn.size()>0&&random(0,1)<.3){
      Goon g=(Goon)spawn.get(0);
      g.inBoss=false;
     monsters.add(g);
     spawn.remove(g); 

     }
     
    }
}
void unique(){
  if(rad<80){
     for(int i =0; i<spawn.size();i++){
      Goon g=(Goon)spawn.get(0);
      g.inBoss=false;
     monsters.add(g);
     spawn.remove(g);
        }
       rad=0;
       deathCountdown--;
       if(deathCountdown==0){
       
         monsters.remove(this);
       }
     }
  counter++;
  if(counter%rate==0){
    addBaddie();
  }
  if(rad/10+40<pointCount){
    pointCount--;
    points.remove(pointCount);
  }
 
}
void addBaddie(){
  Bunger b=new Bunger(pos.copy());
  b.inBoss=true;
     spawn.add(b);
      b=new Bunger(pos.copy());
      b.inBoss=true;
     spawn.add(b);
     Bippo g=new Bippo(pos.copy());
     g.inBoss=true;
     spawn.add(g);

  baddieLevel++;
}

  void render(){
    drawPoints();
     for(int i=0; i<spawn.size();i++){
   Goon g=(Goon)spawn.get(i);
   g.update();
   if(!g.alive){
     spawn.remove(g);
   }
   Vector3D v=g.pos.copy();
   v.sub(pos);
   if(v.magnitudeSquared2D()>rad*rad/4){
     v.mult(.02);
     g.vel.sub(v);
  }
 }
  }


void drawPoints(){
   Vector3D v=new Vector3D();
 fill(150,150,60);
 //stroke(255);
// noSmooth();
 beginShape();
 for(int i=0;i<pointCount;i++){
   if(random(0,1)<.2){
    radCoef[i]=random(radmin,radmax); 
   }
   SpaceBlobDot d = (SpaceBlobDot)points.get(i);
   v.setRTheta(rad/2*radCoef[i],i*TWO_PI/pointCount);
   v.add(pos);
  d.setPoint(v);
  d.update();
  if(i==0||i==pointCount-1){
   curveVertex(d.pos.x,d.pos.y);
  }
  }
endShape();
//smooth();
//noStroke();
 }
 }
class SpaceBlobDot extends Goon{   /////////////////////////////////   point             //////////////////////////////////////////////////////////////
float k=.6;
float b=.04;
float kf=-.1;
SpaceBlobDot friend;
SpaceBlob parent;
Vector3D targetPoint=new Vector3D();
  SpaceBlobDot(Vector3D p,SpaceBlob par){
    mass=6;
    pos= p.copy();
    acc=new Vector3D();
    vel=new Vector3D();
    rad=1;
    type = SPACEBLOBDOT;
    parent=par;
  }
   SpaceBlobDot(Vector3D p,SpaceBlob par,SpaceBlobDot f){
    mass=6;
    pos= p.copy();
    acc=new Vector3D();
    vel=new Vector3D();
    rad=1;
    type = SPACEBLOBDOT;
    parent=par;
    friend=f;
  }
  void checkCollision(){
    if(h.hitWingMan(pos,rad)){
    //println("hit");
    parent.rad-=2;
    parent.vel.mult(1);
    }
  }
void unique(){
  Vector3D f=targetPoint.copy();
  f.sub(pos);
  f.mult(k);
  this.applyForce(f);
  f=vel.copy();
  f.mult(f.magnitude());
  f.mult(-b);
  this.applyForce(f);
  f=friend.pos.copy();
  f.sub(pos);
  f.mult(kf);
  friend.applyForce(f);
}
void setPoint(Vector3D v){
  targetPoint=v;
}
void checkWalls(){
}


  void render(){
      pushMatrix();
  translate(pos.x,pos.y);
  rotate(angle);
 // fill(0,255,255);
  //ellipse(0,0,9,9);
  popMatrix();
    curveVertex(pos.x,pos.y);
  // bezierVertex(pos.x,pos.y,pos.x+10,pos.y,pos.x-10,pos.y);
  }

}
