class Spaceball extends Goon{////////////////////////////////////////     SPACEBALL     /////////////////////
  boolean closed=true;
  float eyeHitArea= .18;//Radians
  float angleMemory=0;
  int spacing =20;
  int eyeRad=15;
  int jaggieCount=50;
  int turtleCounter=0;
  int waitTime=20;
  int moveCounter=0;
  int moveDuration=10;
  boolean attacking=false;
  float attackAngle=0;
  color attackColor;
  int wc=0;
  int count;
  int totalTime=20;
  Eyeball north,south,east,west,top,bottom;
  float turnSpeed=.05;
  ArrayList rollingQue;
  
  Spaceball(Vector3D p){
    pos= p.copy();
    acc=new Vector3D(0,0);
    vel=new Vector3D();
    rad=150;
    rollingQue=new ArrayList();
    makeEyeballs();
    angle=PI/4;

    HitOnSpaceBall l = new HitOnSpaceBall(-PI/2);
     rollingQue.add(l);
     HitOnSpaceBall ll = new HitOnSpaceBall(-PI/2);
     rollingQue.add(ll);
    pos.setXY(width/4,height+rad);
  }
  void unique(){
    if(attacking){
      drawMagic(attackColor,attackAngle);
    }else{
    if(north.dead&&south.dead&&east.dead&&west.dead&&top.dead&&bottom.dead){
      monsters.remove(this);
    }
    if(turtleCounter==waitTime){
      closed=false;
    }
    if(rollingQue.size()>0){
      move();
    }
    else{
      turtleCounter++;
    }
    }
  }
  void move(){
    HitOnSpaceBall h = (HitOnSpaceBall) rollingQue.get(0);
   
    if(moveCounter==0){
      if((abs(TWO_PI+angle-h.angle)%(PI/2))<turnSpeed*2){
        rotateEyes(angle,h.angle);
        angleMemory=angle;
        angle=h.angle;
        vel.setRTheta(PI*rad/moveDuration/2,angle);
        moveCounter=1;

      }
      else{
        if((TWO_PI+angle-h.angle)%(PI/2)-PI/4>0){
          angle+=turnSpeed;
        }
        else{
          angle-=turnSpeed;
        }
      }
    }
    else{
      moveCounter++;
      if(moveCounter==moveDuration){
        rollingQue.remove(h);
        vel.setXY(0,0);
        moveCounter=0;
        angle=angleMemory;
      }
    }
  
  }

void rotateEyes(float orientation, float moveDirection){
  Eyeball temp;
  //println("orientatoin "+orientation+" -----  moveDirection "+moveDirection);
 if(abs(abs(orientation-moveDirection)-PI)<turnSpeed*3){
println("rolling east");
   temp=west; 
   west=top;
   top=east;
   east=bottom;
   bottom=temp;
 }
 if(abs(orientation-moveDirection)<turnSpeed*3){
   println("rolling west");
   temp=west; 
   west=bottom;
   bottom=east;
   east=top;
   top=temp;
 }
  if(abs(orientation-moveDirection-PI/2)<turnSpeed*3){
println("rolling north");
   temp=north; 
   north=top;
   top=south;
   south=bottom;
   bottom=temp;
 }
   if(abs((orientation-moveDirection)+PI/2)<turnSpeed*3){
println("rolling south");
   temp=south; 
   south=top;
   top=north;
   north=bottom;
   bottom=temp;
 }
 

}
  void movement(){

    pos.add(vel);

  }
  void makeEyeballs(){
    north=new Eyeball(color(0,200,200));
    south=new Eyeball(color(40,200,200));
    east=new Eyeball(color(80,200,200));
    west=new Eyeball(color(120,200,200));
    top=new Eyeball(color(160,200,200));
    bottom=new Eyeball(color(200,200,200));
  }
  void render(){ ///////////render the spaceBall
    pushMatrix();
    translate(pos.x,pos.y);
    if(!closed){ 
      rotate(angle);
      drawPopped();
       updateEyes();
      
    }
    else{
      drawSparkQue();
      rotate(angle);
      drawLocked();
      //updateEyes();

    }
    popMatrix();
  }
  void updateEyes(){

    float a =(atan2(pos.y-h.pos.y,pos.x-h.pos.x))-angle;
    int buggyness=8;
    if(!bottom.dead){
      bottom.update(0,0,a);
    }
    if(!top.dead){
      top.update(0,0,a);
    }
    if(!north.dead){
      north.update(0,rad+buggyness,a);
    }
    if(!south.dead){
      south.update(0,-rad-buggyness,a);
    }
    if(!east.dead){
      east.update(rad+buggyness,0,a);
    }
    if(!west.dead){
      west.update(-rad-buggyness,0,a);
    }

  }
  void checkCollision(){
    if(closed){
    h.hitWingMan(pos,rad*2+30);
    }
    else{
      h.hitWingMan(pos,rad*2+70);
    }
    int erad=rad+spacing*2;
    Vector3D p,v;
    WingMan w = h.leftWingMan;
    for(int i=0; i<2; i++){
      p=w.getPosition().copy();
      p.sub(pos);
      float m = p.magnitude();
      if(m<erad){/////////////////A wing man has hit! wow yaaay hazzah.
        
        turtleCounter=0;
        v=w.getVelocity();
        p.mult(.02*(-m+erad));
        v.add(p);
        HitOnSpaceBall hi=new HitOnSpaceBall(p.heading2D());
        //println(degrees(p.heading2D()));
        rollingQue.add(hi); 
        
        if(!closed){
          closed=true;
          float eyeHitTest = (TWO_PI+hi.angle-angle%TWO_PI)%TWO_PI-PI;
          if(abs(eyeHitTest)<eyeHitArea){
            if(!west.dead){
              closed=false;
            attackAngle=angle+PI/2;
            attackColor=west.col;
            attacking=true;
            }
            west.dead=true;
          }
          else if(abs(eyeHitTest-PI/2)<eyeHitArea){
            if(!south.dead){
              closed=false;
            attackAngle=angle+PI;
            attackColor=south.col;
            attacking=true;
            }
            south.dead=true;

          }
          else if(abs(eyeHitTest)>PI-eyeHitArea){
            if(!east.dead){
              closed=false;
           attackAngle=angle-PI/2;
            attackColor=east.col;
            attacking=true;
            } 
            east.dead=true;
          }
          else if(abs(eyeHitTest+PI/2)<eyeHitArea){
            if(!north.dead){
              closed=false;
            attackAngle=angle;
            attackColor=north.col;
            attacking=true;
            }
            north.dead=true;
          }
        }
        
      }
      w=h.rightWingMan;
    }

  }
  void drawLocked(){///////DrawClosed Spaceball
    fill(120);
    ellipse(0,0,rad*2,rad*2);
    stroke(0);
    pushMatrix();
    if(moveCounter>0){
      HitOnSpaceBall h=(HitOnSpaceBall) rollingQue.get(0);
      rotate(angle-h.angle);
    }      
    float controlPoint = (float)rad*moveCounter/moveDuration;
    float corrFactor=1.4;
    bezier(0,rad,controlPoint*corrFactor,rad,controlPoint*corrFactor,-rad,0,-rad);
    bezier(0,rad,(controlPoint-rad)*corrFactor,rad,(controlPoint-rad)*corrFactor,-rad,0,-rad);
    line(rad,0,-rad,0);
    popMatrix();
    noStroke();
  }
  void drawPopped(){//////DrawOpenSpaceBall!

    drawJaggies();
    for(int i=0; i<4;i++){
      drawWedge(0,0,PI/2*i);
    }
  }
  void drawSparkQue(){
    int queSize = rollingQue.size();
    stroke(230);
    noSmooth();
    for(int i=0;i<queSize;i++){
      HitOnSpaceBall h =(HitOnSpaceBall) rollingQue.get(i);
      pushMatrix();
      rotate(h.angle);
      line(rad,0,rad+random(10,20),random(-10,10));
      line(rad,0,rad+random(10,20),random(-10,10));
      popMatrix();
    }
    smooth();
    noStroke(); 
  }

  void drawJaggies(){
    stroke(230);
    noSmooth();
    for(int i=0;i<jaggieCount;i++){
      line(random(-rad-spacing,rad+spacing),-spacing,random(-rad-spacing,rad+spacing),spacing);
      line(-spacing,random(-rad-spacing,rad+spacing),spacing,random(-rad-spacing,rad+spacing));
    }
    noStroke();
    smooth();

  }

  void drawWedge(float x, float y, float a){
    fill(120);
    pushMatrix();
    rotate(a);
    translate(x+spacing,y+spacing);
    beginShape(POLYGON);
    vertex(0,0);
    vertex(0,rad);
    bezierVertex(rad,rad,rad,0,rad,0);
    vertex(rad,0);
    endShape(); 
    popMatrix();
  }
  void drawMagic(color c,float ang){
  pushMatrix();
  translate(pos.x,pos.y);
  rotate(ang);
  wc++;
  wc=wc%totalTime;
  if(wc==totalTime/2){
    attacking=false;
    closed=true;
    }
  count=abs(totalTime/2-wc);
     //drawTop();
   drawSpines(attackColor);
   fill(c);
   noStroke();
   drawGrowingBall(-45,15,75);
   drawGrowingBall(45,15,75);
   drawGrowingBall(0,130,150);
   drawGrowingBall(0,350,200);
   fill(0);
   drawGrowingBall(0,350,170);
   drawGrowingBall(0,130,120);
   for(int i = 0; i<12;i++){
   drawHole(attackColor);
   }

  doHicky(0,15,30,min(count,7),c);
    //doHicky(0,15,-10,min(count,7),c);

 //drawEye();
 //drawOpening();
 popMatrix();
  }
  


void drawTop(color c){
 for(int i=0;i<10;i++){
  color n= color(hue(c)+i,saturation(c)+i,brightness(c)+i);
 fill(n);
 pushMatrix();
 translate(0,-140);
 rotate(PI/2/totalTime*i*count/8);
 ellipse(0,500,count-i,2*count-i);
 rotate(-2*i*count*PI/2/totalTime/2);
  ellipse(0,500,count-i,2*count-i);
  popMatrix();
 } 
}
void drawGrowingBall(int x, int y, int maxRad){
 ellipse(x,y,maxRad*count/totalTime,maxRad*count/totalTime); 
}
 void drawSpines(color c){
   pushMatrix();
   translate(0,-280);
   int spineCount=8;
   int spineHeight=640;
   int bob;
   float slope = 1/(count+.0001)*10;
  for(int i=1;i<=spineCount;i++){
    bob =i*spineHeight/spineCount;
    if(i>3){
    curvyTri(bob/slope,bob,c,spineHeight);
    }
    stroke(c);
    noSmooth();
   bezier(0,0,0,spineHeight,0,0,bob/slope,bob);
   bezier(0,0,0,spineHeight,0,0,-bob/slope,bob);
   
   
  } 
  noStroke();
  smooth();
  popMatrix();
 }
 void curvyTri(float x, float y,color g,int ymax){
   color col=color(hue(g),saturation(g),100*x/ymax);
   fill(col);
   noStroke();
   beginShape(POLYGON);
   vertex(x,y);
   bezierVertex(0,ymax,0,ymax,0,ymax/2);
   bezierVertex(0,ymax,0,ymax,-x,y);
   bezierVertex(0,ymax/2,0,ymax/2,x,y);
   endShape();
   //ellipse(x,y,20,20);
 }
 void drawOpening(){
   pushMatrix();
   stroke(255);
    translate(0,-280);
    rotate(count*PI/2/totalTime);
    line(-8,0,-8,280);
    rotate(-count*PI/totalTime);
    line(8,0,8,280);
    noStroke();
    popMatrix();
  }
   void drawHole(color c){
   pushMatrix();
    translate(0,-140);
    rotate(random(-count*PI/2/totalTime,count*PI/2/totalTime));
    fill(0);
    float y = random(0,500);
    ellipse(0,y,10,10);
    fill(c);
    ellipse(0,y+10,4,4);
    ellipse(0,y-10,4,4);
    ellipse(10,y,4,4);
    ellipse(-10,y,4,4);
   popMatrix();
  }
 
  void doHicky(float x, float y,float r, float level,color c){
   if(level>0){
     
     fill(c);
     c=color(hue(c)-3,saturation(c)+3,brightness(c)+1);
    ellipse(x,y,r,r);
    doHicky(x*1.1+r*r*.09,y+r*1.2,r*.8,level-1,c);
    doHicky(x*1.1-r*r*.09,y+r*1.2,r*.8,level-1,c);
   }else{
 noSmooth();
 stroke(c);
     line(x,y,x*1.4,y+6);
     noStroke();
     smooth();
  }
  }
}

class HitOnSpaceBall{
  public float angle;
  HitOnSpaceBall(float a){
    angle=a;
  }
}
class Eyeball extends Goon{
  public color col;
  public boolean dead=false;
  Eyeball(color c){
    col=c;
    rad=40;
    pos=new Vector3D();
  }
  void update(int x, int y,float a){

    pushMatrix();
    translate(x,y);
 
    fill(255);
    ellipse(0,0,rad,rad);
    pushMatrix();

    rotate(a);
    fill(col);
    ellipse(-rad/6,0,rad*.55,rad*.55);
    fill(0);
    ellipse(-rad/6,0,rad*.3,rad*.3);
    popMatrix();
    fill(255);
    ellipse(7,9,8,8);
    popMatrix();

  }

}

